//NTP TZ DST - bare minimum
//  NetWork Time Protocol - Time Zone - Daylight Saving Time
//
//  Our target for this MINI sketch is:
//  - get the SNTP request running
//  - set the timezone
//  - (implicit) respect daylight saving time
//  - how to "read" time to be printed to Serial.Monitor
//
//  This example is a stripped down version of the NTP-TZ-DST (v2)
//  And works for ESP8266 core 2.7.4
//
//  by noiasca
//  2020-09-22
//*/

#ifndef STASSID
#define STASSID "MIWIFI_2G_4E4H"                            // set your SSID
#define STAPSK  "YaM7rPuc"                        // set your wifi password
#endif

// neopixels: pin number & pixel count.
const int neo = D5; // Pin where NeoPixels are connected 12
const int pixel_count = 8; // number of neopixels



// radarmotionsensor: pin number & detection flag.
const int motion = D2;
int sensorVal = 0;



/* Configuration of NTP */
#define MY_NTP_SERVER "europe.pool.ntp.org"
#define MY_TZ "CET-1CEST,M3.5.0/02,M10.5.0/03"


/* Necessary Includes */
#include <ESP8266WiFi.h>            // we need wifi to get internet access
#include <time.h>                   // time() ctime()
#include <moonPhaser.h>;
#include <Adafruit_NeoPixel.h>// moonphase for esp8266


Adafruit_NeoPixel strip = Adafruit_NeoPixel(neo, pixel_count, NEO_GRB + NEO_KHZ800);

// moon phase: include a MoonPhase instance
moonPhaser moonPhase;

// moon phase: variable to receive the data
moonData_t moon;

/* Globals */
time_t now;                         // this is the epoch
tm tm;
//

void newmoon() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  Serial.println("newmoon-light");
};

void waxingcrescent() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  Serial.println("waxingscrescent-light");
};

void firstquarter() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  Serial.println("firstquarter-light");
};

void waxinggibbous() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  Serial.println("waxinggibbous-light");
};
//
void fullmoon() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  Serial.println("fullmoon-light");
};
//
void waninggibbous() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  ; //Show The Color
  Serial.println("waninggibbous-light");
};


void thirdquarter() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  Serial.println("thirdquarter-light");
};

void waningcrescent() {
  strip.setPixelColor(0, 255, 0, 0);
  strip.setPixelColor(1, 255, 0, 0);
  strip.setPixelColor(2, 255, 0, 0);
  strip.setPixelColor(3, 255, 0, 0);
  strip.setPixelColor(4, 255, 0, 0);
  strip.setPixelColor(5, 255, 0, 0);
  strip.setPixelColor(6, 255, 0, 0);
  strip.setPixelColor(7, 255, 0, 0);
  strip.setPixelColor(8, 255, 0, 0);
  strip.setPixelColor(9, 255, 0, 0);
  ; //Show The Color
  Serial.println("waningcrescent-light");
};










void showTime() {                     // the structure tm holds time information in a more convient way


  { time(&now);                       // read the current time
    delay(20);
    localtime_r(&now, &tm);           // update the structure tm with the current time
    Serial.print("year:");
    Serial.print(tm.tm_year + 1900);  // years since 1900
    Serial.print("\tmonth:");
    Serial.print(tm.tm_mon + 1);      // January = 0 (!)
    Serial.print("\tday:");
    Serial.print(tm.tm_mday);         // day of month
    Serial.print("\thour:");
    Serial.print(tm.tm_hour);         // hours since midnight  0-23
    Serial.print("\tmin:");
    Serial.print(tm.tm_min);          // minutes after the hour  0-59
    Serial.print("\tsec:");
    Serial.print(tm.tm_sec);          // seconds after the minute  0-61*
    Serial.print("\twday");
    Serial.print(tm.tm_wday);         // days since Sunday 0-6
    if (tm.tm_isdst == 1)             // Daylight Saving Time flag
      Serial.print("\tDST");
    else
      Serial.print("\tstandard");
    Serial.println();
    delay(20);
  }


  int32_t currentYear = tm.tm_year + 1900;
  int32_t currentMonth = tm.tm_mon + 1;
  int32_t monthDay = tm.tm_mday;
  double currentHour = tm.tm_hour;


  moon = moonPhase.getPhase(currentYear, currentMonth, monthDay, currentHour);
  // Waxing: 0-180
  // Waning: 180-360
  Serial.print( "Moon angle: " );
  Serial.print( moon.angle );             // moon.angle is a integer between 0-360
  Serial.println( " degrees." );
  Serial.print( "Moon surface lit: " );
  Serial.println( moon.percentLit * 100 );  // value is between 0 & 1
}



void setup() {
  Serial.begin(115200);
  show();
  strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(50); // Set BRIGHTNESS to about 1/5 (max = 255)



  //
  Serial.println("\nNTP TZ DST - bare minimum");
  configTime(MY_TZ, MY_NTP_SERVER); // --> Here is the IMPORTANT ONE LINER needed in your sketch!


  // Start network
  WiFi.persistent(false);
  WiFi.mode(WIFI_STA);
  WiFi.begin(STASSID, STAPSK);
  while (WiFi.status() != WL_CONNECTED) {
    delay(200);
    Serial.print ( "." );
  }
  Serial.println("WiFi connected");
  // by default, the NTP will be started after 60 secs

  pinMode (neo, OUTPUT);    //Neo as OUTPUT
  pinMode (motion, INPUT);  // RCWL-0516 output is input for Nano
  digitalWrite (neo, LOW);  // Initialize all pixels to 'off'
//
  strip.show();
}



void loop() {
  sensorVal = digitalRead (motion);// read sensor value
  delay(3000);
if (sensorVal == 0)
  {
   digitalWrite(neo, LOW);
   Serial.println ("led off ");
   }

else if (sensorVal == 1)
   { 
  strip.show(); //Show The Color
 
  showTime();
  digitalWrite(neo, HIGH);
  Serial.println ("led on ");

  if (((0 <= moon.angle) && (moon.angle < 1))) {
    newmoon();
    Serial.println("newmoon");
  }

  else if ((1 <= moon.angle) && ( moon.angle < 90)) {
    waxingcrescent();
    Serial.println("waxingcrescent");
  }

  else if ((89 < moon.angle) && (moon.angle <= 90)) {
    firstquarter();
    Serial.println("firstquarter");
  }

  else if ((90 < moon.angle) && (moon.angle <= 179)) {
    waxinggibbous();
    Serial.println("waxinggibbous");
  }

  else if (((179 < moon.angle) && (moon.angle <= 180)) || ((359 <= moon.angle) && (moon.angle <= 360))) {
    //    fullmoon();
    Serial.println("fullmoon");
  }

  else if ((180 < moon.angle) && (moon.angle < 269)) {
    waninggibbous();
    Serial.println("waninggibbous");
  }

  else if ((269 <= moon.angle) && (moon.angle <= 270)) {
    thirdquarter();
    Serial.println("thirdquarter");
  }

  else if ((271 < moon.angle) && (moon.angle < 359)) {
    waningcrescent ();
    Serial.println("waningcrescent");
  }
   delay(60000);     // during this period the led will be ON                                     
}
}
