  //  This example is a stripped down version of the NTP-TZ-DST (v2)
//  And works for ESP8266 core 2.7.4
//
//  by noiasca
//  2020-09-22
//*/






#include <FastLED.h>                 // Adafruit strip.begin() was clashing with wifi.
#include <ESP8266WiFi.h>            // we need wifi to get internet access
#include <time.h>                   // time() ctime()
#include <moonPhaser.h>;            // our lovely moon



#ifndef STASSID
//#define STASSID "MIWIFI_2G_4E4H"                            // set your SSID
//#define STAPSK  "YaM7rPuc"                        // set your wifi password
#define STASSID "Iaac-Wifi"                            // set your SSID
#define STAPSK  "enteriaac2013"                        // set your wifi password
#endif


// FASTLED
#define LED_PIN 4
#define NUM_LEDS    94
#define CHIPSET     WS2811
#define COLOR_ORDER GRB
CRGB leds[NUM_LEDS];

// radarmotionsensor: pin number & detection flag.
const int motion = 5;
int sensorVal = 0;


/* Configuration of NTP */
#define MY_NTP_SERVER "europe.pool.ntp.org"
#define MY_TZ "CET-1CEST,M3.5.0/02,M10.5.0/03"


// moon phase: include a MoonPhase instance
moonPhaser moonPhase;

// moon phase: variable to receive the data
moonData_t moon;

/* Globals */
time_t now;                         // this is the epoch
tm tm;

void newmoon() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("newmoon-light");
};

void waxingcrescent() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("waxingscrescent-light");
};

void firstquarter() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("firstquarter-light");
};

void waxinggibbous() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("waxinggibbous-light");
};
//
void fullmoon() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("fullmoon-light");
};
//
void waninggibbous() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("waninggibbous-light");
};


void thirdquarter() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("thirdquarter-light");
};

void waningcrescent() {
  leds[0] = CRGB::Red;
  leds[1] = CRGB::Red;
  leds[2] = CRGB::Red;
  leds[3] = CRGB::Red;
  leds[4] = CRGB::Red;
  leds[5] = CRGB::Red;
  leds[6] = CRGB::Red;
  leds[7] = CRGB::Red;
  FastLED.show();
  Serial.println("waningcrescent-light");
};


void showTime() {                     // the structure tm holds time information in a more convient way
  
  time(&now);                       // read the current time
  delay(20);
  localtime_r(&now, &tm);           // update the structure tm with the current time
  Serial.println("year:");
  Serial.println(tm.tm_year + 1900);  // years since 1900
  Serial.println("\tmonth:");
  Serial.println(tm.tm_mon + 1);      // January = 0 (!)
  Serial.println("\tday:");
  Serial.println(tm.tm_mday);         // day of month
  Serial.println("\thour:");
  Serial.println(tm.tm_hour);         // hours since midnight  0-23
  Serial.println("\tmin:");
  Serial.println(tm.tm_min);          // minutes after the hour  0-59
  Serial.println("\tsec:");
  Serial.println(tm.tm_sec);          // seconds after the minute  0-61*
  Serial.println("\twday");
  Serial.println(tm.tm_wday);         // days since Sunday 0-6

  
  if (tm.tm_isdst == 1)             // Daylight Saving Time flag
    Serial.println("\tDST");
  else
    Serial.println ("\tstandard");
  Serial.println();
  delay(20);



  int32_t currentYear = tm.tm_year + 1900;
  int32_t currentMonth = tm.tm_mon + 1;
  int32_t monthDay = tm.tm_mday;
  double currentHour = tm.tm_hour;


  moon = moonPhase.getPhase(currentYear, currentMonth, monthDay, currentHour);
  // Waxing: 0-180
  // Waning: 180-360
  Serial.print( "Moon angle: " );
  Serial.print( moon.angle );             // moon.angle is a integer between 0-360
  Serial.println( " degrees." );
  Serial.print( "Moon surface lit: " );
  Serial.println( moon.percentLit * 100 );  // value is between 0 & 1
}




void setup() {
  Serial.begin(115200);
  FastLED.addLeds<CHIPSET, LED_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection( TypicalSMD5050 );

  //
  Serial.println("\nNTP TZ DST - bare minimum");
  configTime(MY_TZ, MY_NTP_SERVER); // --> Here is the IMPORTANT ONE LINER needed in your sketch!


  // Start network
  WiFi.persistent(false);
  WiFi.mode(WIFI_STA);
  WiFi.begin(STASSID, STAPSK);
  while (WiFi.status() != WL_CONNECTED) {
    delay(200);
    Serial.print ( "." );
  }
  Serial.println("WiFi connected");
  // by default, the NTP will be started after 60 secs
  pinMode (motion, INPUT);  // RCWL-0516 output is input for Nano
}



void loop() {
            
  sensorVal = digitalRead (motion); // read sensor value
  if (sensorVal == 0)
  {
    FastLED.clear();
    FastLED.show();
    Serial.println ("led off");
  }

  else if (sensorVal == 1)
  {
    showTime();
    Serial.println ("led on");

    
    if (((0 <= moon.angle) && (moon.angle < 1))) {
      newmoon();
      Serial.println("newmoon");
    }

    else if ((1 <= moon.angle) && ( moon.angle < 90)) {
      waxingcrescent();
      Serial.println("waxingcrescent");
    }

    else if ((89 < moon.angle) && (moon.angle <= 90)) {
      firstquarter();
      Serial.println("firstquarter");
    }

    else if ((90 < moon.angle) && (moon.angle <= 179)) {
      waxinggibbous();
      Serial.println("waxinggibbous");
    }

    else if (((179 < moon.angle) && (moon.angle <= 180)) || ((359 <= moon.angle) && (moon.angle <= 360))) {
      //    fullmoon();
      Serial.println("fullmoon");
    }

    else if ((180 < moon.angle) && (moon.angle < 269)) {
      waninggibbous();
      Serial.println("waninggibbous");
    }

    else if ((269 <= moon.angle) && (moon.angle <= 270)) {
      thirdquarter();
      Serial.println("thirdquarter");
    }

    else if ((271 < moon.angle) && (moon.angle < 359)) {
      waningcrescent ();
      Serial.println("waningcrescent");
    }
    FastLED.clear(); 
    delay(200);// during this period the led will be ON                                     
  }
}
