// Library
#include <Adafruit_NeoPixel.h>
#include <moonPhaser.h>
#include <ESP8266WiFi.h>
#include <NTPClient.h>
#include <WiFiUdp.h>
#include <time.h>



// neopixels: pin number & pixel count.
const int neo = D6; // Pin where NeoPixels are connected 12
const int pixel_count = 8; // number of neopixels

////Neopixel setup
//Adafruit_NeoPixel pixels(neo, pixel_count, NEO_GRB + NEO_KHZ800);

WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "europe.pool.ntp.org");

// moon phase: include a MoonPhase instance
moonPhaser moonPhase;

// moon phase: variable to receive the data
moonData_t moon;

//Wifi credentials
const char *ssid = "MIWIFI_2G_4E4H";
const char *password = "YaM7rPuc";


int monthDay;
int currentMonth;
int currentYear;
int angle;

void setup() {
  Serial.begin(115200);
  //pixels.begin();

  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
}

void loop() {

  // Initialize a NTPClient to get time
  timeClient.begin();
  timeClient.setTimeOffset(7200);

  timeClient.update();

  unsigned long epochTime = timeClient.getEpochTime();
  Serial.print("Epoch Time: ");
  Serial.println(epochTime);

  //Get a time structure
  struct tm *ptm = gmtime ((time_t *)&epochTime);

  int monthDay = ptm->tm_mday;
    Serial.print("Month day: ");
    Serial.println(monthDay);

  int currentMonth = ptm->tm_mon + 1;
    Serial.print("Month: ");
    Serial.println(currentMonth);

  int currentYear = ptm->tm_year + 1900;
    Serial.print("Year: ");
    Serial.println(currentYear);

  int currentHour = timeClient.getHours();
    Serial.print("Hour: ");
    Serial.println(currentHour);

  moon = moonPhase.getPhase(currentYear, currentMonth, monthDay, currentHour);

  // Waxing: 0-180
  // Waning: 180-360
  Serial.print( "Moon phase angle: " );
  Serial.print( moon.angle );             // angle is a integer between 0-360
  Serial.println( " degrees." );
  Serial.print( "Moon surface lit: " );
  Serial.println( moon.percentLit * 100 );  // value is between 0 & 1

  delay(3000);

}
//  if (0 = < angle < 1 or 359 < angle = < 360) {
//    //    newmoon();
//    Serial.println(newmoon);
//  }
//  else if (1 = < angle < 90) {
//    //    waxingcrescent();
//    Serial.println(waxingcrescent);
//  }
//  else if (89 < angle = < 90) {
//    //    firstquarter();
//    Serial.println(firstquarter);
//  }
//  else if (90 < angle = < 179) {
//    //    waxinggibbous();
//    Serial.println(waxinggibbous);
//  }
//  else if (179 < angle = < 180) {
//    //    fullmoon();
//    Serial.println(fullmoon);
//  }
//  else if (180 < angle < 269) {
//    //    waninggibbous();
//    Serial.println(waninggibbous);
//  }
//  else if  (269 < angle = < 270) {
//  //    thirdquarter();
//  Serial.println(thirdquarter);
//  }
//  else if (271 < angle < 359) {
//  //    waningcrescent ();
//  Serial.println(waningcrescent);
//  }


















//  if (0 =< angle < 1 or 359 < angle =< 360) {
////    newmoon();
//    Serial.println(newmoon);
//  };
//  else if (1 =< angle < 90) {
////    waxingcrescent();
//    Serial.println(waxingcrescent);
//  };
//  else if (89 < angle =< 90) {
////    firstquarter();
//    Serial.println(firstquarter);
//  };
//  else if (90 <angle =< 179)) {
////    waxinggibbous();
//    Serial.println(waxinggibbous);
//  };
//  else if (179 < angle =< 180) {
////    fullmoon();
//    Serial.println(fullmoon);
//  }
//  else if (180 < angle < 269) {
////    waninggibbous();
//    Serial.println(waninggibbous);
//  };
//  else if  269 <angle =< 270) {
////    thirdquarter();
//    Serial.println(thirdquarter);
//  };
//  else if (271 < angle < 359) {
////    waningcrescent ();
//    Serial.println(waningcrescent);
//  };
//
//
//
//pixels.show();   // Send the updated pixel colors to the hardware.
//delay(100000); // Pause before next pass through loop
//  }
//// moon phases
//void newmoon() {
//  pixels.setPixelColor(0, pixels.Color(0, 150, 0));
//};
//
//void waxingcrescent() {
//  pixels.setPixelColor(0, pixels.Color(0, 150, 0));
//};
//
//void firstquarter() {
//  pixels.setPixelColor(1, pixels.Color(0, 150, 0));
//};
//
//void waxinggibbous() {
//  pixels.setPixelColor(2, pixels.Color(0, 150, 0));
//};
//
//void fullmoon() {
//  pixels.setPixelColor(3, pixels.Color(0, 150, 0));
//};
//
//void waninggibbous() {
//  pixels.setPixelColor(4, pixels.Color(0, 150, 0));
//};
//
//void thirdquarter() {
//  pixels.setPixelColor(5, pixels.Color(0, 150, 0));
//};
//
//void waningcrescent() {
//  pixels.setPixelColor(6, pixels.Color(0, 150, 0));
//};
//
